import direct.directbase.DirectStart
from direct.actor import Actor
from direct.task import Task
import math
#1
from pandac.PandaModules import *
from direct.interval.IntervalGlobal import *
from CameraHandler import CameraHandler 
from direct.showbase import DirectObject 

#Load Sound
mySoundTiTle = loader.loadSfx("02-Kill You.mp3")
mySoundTiTle.play()

#Load model
environ =loader.loadModel("models/environment")
environ.reparentTo(render)
environ.setScale(0.25,0.25,0.25)
environ.setPos(-8,42,0)


pandaActor = Actor.Actor("models/panda-model",{"walk":"models/panda-walk4"}) 
pandaActor.setScale(0.005,0.005,0.005) 
pandaActor.reparentTo(render) 


#TEKST
from direct.gui.OnscreenText import OnscreenText
textObject = OnscreenText(text = 'my text string', pos = (-0.5, 0.02), scale = 0.07)

#Task Povorot camers
def SpinCameraTask(task):
 angledegrees = task.time * 6.0
 angleradians = angledegrees * (math.pi/180.0)
 base.camera.setPos(20*math.sin(angleradians),-20.0*math.cos(angleradians),3)
 base.camera.setHpr(angledegrees,0,0)
 return Task.cont

taskMgr.add(SpinCameraTask, "SpinCameraTask")
#Import Panda and its animation
#Run Render

base.disableMouse() 


camCenter = render.attachNewNode('camCenter')   
base.camera.reparentTo(camCenter) 

base.camera.setPos(0,20,8) 
base.camera.lookAt(camCenter) 


class KeyHandler(DirectObject.DirectObject): 
      def __init__(self): 
          self.speed=0 
          self.turnspeed=0 
          self.accept('w',lambda: self.walk(-15)) 
          self.accept('s',lambda: self.walk(15)) 
          self.accept('d',lambda: self.turn(-1)) 
          self.accept('a',lambda: self.turn(1)) 
          self.accept('w-up',lambda: self.walk(0)) 
          self.accept('s-up',lambda: self.walk(0)) 
          self.accept('d-up',lambda: self.turn(0)) 
          self.accept('a-up',lambda: self.turn(0))          
          taskMgr.add(self.moveTask,"moveTask")    
      def walk(self,speed): 
          self.speed=speed 
          if speed==0: 
              pandaActor.stop()      
          else: 
              pandaActor.loop("walk")      
              pandaActor.getAnimCo ntrol("walk").setPlayRate(self.speed*0.15)               
      def turn(self,turnspeed): 
          self.turnspeed=turnspeed 
      def moveTask(self,task): 
          pandaActor.setPos(pandaActor,0,self.speed,0) 
          pandaActor.setH(pandaActor.getH()+self.turnspeed) 
          camCenter.setPos(pandaActor.getX(),pandaActor.getY(),pandaActor.getZ()+5) 
          camCenter.setHpr(pandaActor.getHpr()) 
          return task.cont 

KeyHandler() 

run()    